/*---------------------------------------------------------------------------
	KEYLIB.C

	Version 1.00 (C)Copyright Andrew Trzeciak. 1993
*/
#include "bioskeys.h"
#include "keylib.h"

static const unsigned char scancodes[0x80] =
{
0xFF,
KB_SC_C_A,
KB_SC_C_B,
KB_SC_C_C,
KB_SC_C_D,
KB_SC_C_E,
KB_SC_C_F,
KB_SC_C_G,
KB_SC_N_BACKSPACE,
KB_SC_N_TAB,
KB_SC_C_J,
KB_SC_C_K,
KB_SC_C_L,
KB_SC_N_ENTER,
KB_SC_C_N,
KB_SC_C_O,
KB_SC_C_P,
KB_SC_C_Q,
KB_SC_C_R,
KB_SC_C_S,
KB_SC_C_T,
KB_SC_C_U,
KB_SC_C_V,
KB_SC_C_W,
KB_SC_C_X,
KB_SC_C_Y,
KB_SC_C_Z,
KB_SC_N_ESC,
KB_SC_C_BACKSLASH,
0xFF,
0xFF,
KB_SC_C_MINUS,
KB_SC_N_SPACE,
KB_SC_S_1,
KB_SC_S_QUOTE,
KB_SC_S_3,
KB_SC_S_4,
KB_SC_S_5,
KB_SC_S_7,
KB_SC_N_QUOTE,
KB_SC_S_9,
KB_SC_S_0,
KB_SC_S_8,
KB_SC_N_PAD_PLUS,
KB_SC_N_COMMA,
KB_SC_N_MINUS,
KB_SC_N_PERIOD,
KB_SC_N_SLASH,
KB_SC_N_0,
KB_SC_N_1,
KB_SC_N_2,
KB_SC_N_3,
KB_SC_N_4,
KB_SC_N_5,
KB_SC_N_6,
KB_SC_N_7,
KB_SC_N_8,
KB_SC_N_9,
KB_SC_S_SEMI,
KB_SC_N_SEMI,
KB_SC_S_COMMA,
KB_SC_N_EQUALS,
KB_SC_S_PERIOD,
KB_SC_S_SLASH,
KB_SC_S_2,
KB_SC_S_A,
KB_SC_S_B,
KB_SC_S_C,
KB_SC_S_D,
KB_SC_S_E,
KB_SC_S_F,
KB_SC_S_G,
KB_SC_S_H,
KB_SC_S_I,
KB_SC_S_J,
KB_SC_S_K,
KB_SC_S_L,
KB_SC_S_M,
KB_SC_S_N,
KB_SC_S_O,
KB_SC_S_P,
KB_SC_S_Q,
KB_SC_S_R,
KB_SC_S_S,
KB_SC_S_T,
KB_SC_S_U,
KB_SC_S_V,
KB_SC_S_W,
KB_SC_S_X,
KB_SC_S_Y,
KB_SC_S_Z,
KB_SC_N_LBRACKET,
KB_SC_N_BACKSLASH,
KB_SC_N_RBRACKET,
KB_SC_S_6,
0xFF,
KB_SC_N_BACKQUOTE,
KB_SC_N_A,
KB_SC_N_B,
KB_SC_N_C,
KB_SC_N_D,
KB_SC_N_E,
KB_SC_N_F,
KB_SC_N_G,
KB_SC_N_H,
KB_SC_N_I,
KB_SC_N_J,
KB_SC_N_K,
KB_SC_N_L,
KB_SC_N_M,
KB_SC_N_N,
KB_SC_N_O,
KB_SC_N_P,
KB_SC_N_Q,
KB_SC_N_R,
KB_SC_N_S,
KB_SC_N_T,
KB_SC_N_U,
KB_SC_N_V,
KB_SC_N_W,
KB_SC_N_X,
KB_SC_N_Y,
KB_SC_N_Z,
KB_SC_S_LBRACKET,
KB_SC_S_BACKSLASH,
KB_SC_S_RBRACKET,
KB_SC_S_BACKQUOTE,
KB_SC_C_BACKSPACE
};

/*---------------------------------------------------------------------------

*/
int kb_ch2sc (int ch)
{

return ch >= 0 && ch <= 127 ? scancodes[ch] : (unsigned char)0xFF;
}
